import 'dart:typed_data';

import 'package:binarize/binarize.dart';
import 'package:test/test.dart';

void main() {
  final result = Uint8List.fromList([5, 78, 32]);

  test('Should store the PayloadType and value correctly', () {
    final writer = Payload.write();
    writer.set(uint8, 5);
    writer.set(uint16, 20000);

    expect(writer.length, 3);
    expect(binarize(writer), result);
  });

  test('Should read the PayloadType and value correctly', () {
    final reader = Payload.read(result);
    final uInt8 = reader.get(uint8);
    final uInt16 = reader.get(uint16);

    expect(reader.length, 3);
    expect(uInt8, 5);
    expect(uInt16, 20000);
  });
}
